
; Public Domain

%include "lmacros3.mac"
%include "eld.mac"
%include "eldcall.mac"
%include "elddata.mac"

	addsection RELOCATEDDATA, nobits vstart=8000h
relocateddata:

	addsection HEADER, start=0

		; ELD executable header
	istruc ELD_HEADER
at eldhSignature,	db "ELD1"
			db 0,0,0
			db 26
at eldhCodeOffset,	dd CODEOFFSET
at eldhCodeImageLength,	dw code_size
at eldhCodeAllocLength,	dw 0
at eldhDataOffset,	dd DATAOFFSET
at eldhDataImageLength,	dw data_size
at eldhDataAllocLength,	dw total_data_size - data_size
at eldhCodeEntrypoint,	dw linker - code
at eldhReserved
	iend


	align 16, db 0

CODEOFFSET equ $ - $$
	addsection CODE, follows=HEADER vstart=_ELD_CODE_VSTART
%define CODEFIXUP - code + 0
code:
		; ELD instance header
	istruc ELD_INSTANCE
at eldiStartCode
at eldiEndCode
at eldiStartData
at eldiEndData
at eldiIdentifier,	fill 8, 32, db "RECLAIM"
	iend


start:
	mov ax, word [cs:code + eldiEndCode]
internalcoderelocation
	sub ax, word [cs:code + eldiStartCode]
internalcoderelocation
	sub word [relocateddata], ax
linkdatarelocation extseg_used

	mov ax, word [cs:code + eldiEndData]
internalcoderelocation
	sub ax, word [cs:code + eldiStartData]
internalcoderelocation
	sub word [relocateddata], ax
linkdatarelocation extdata_used


loop_free_data:
.outer:
	xor si, si
.inner:
	mov bx, [relocateddata]
linkdatarelocation extdata_used
	add bx, [relocateddata]
linkdatarelocation extdata
	cmp si, [relocateddata]
linkdatarelocation extseg_used		; behind last instance ?
	jae .end			; yes -->
	cmp word [es:si + eldiStartCode], si
	jne .error			; start matches itself ?
	testopt [es:si + eldiFlags], eldifResident
	jnz .next			; is free ?
	mov dx, word [es:si + eldiEndData]
	cmp dx, bx			; end > last data ?
	ja .error			; yes, error -->
	jne .next			; end == last data ?
					; yes, free it
	mov ax, dx
	sub ax, word [es:si + eldiStartData]
	jc .error
	cmp ax, word [relocateddata]
linkdatarelocation extdata_used
	ja .error
	sub word [relocateddata], ax
linkdatarelocation extdata_used
	xor ax, ax
	mov word [es:si + eldiStartData], ax
	mov word [es:si + eldiEndData], ax
	jmp .outer			; restart search for trailing data

.next:
	mov dx, si
	add dx, ELD_INSTANCE_size
	mov si, word [es:si + eldiEndCode]
	cmp si, dx
	jb .error
	jmp .inner

.error:
	mov ax, -3
	retf

.end:


loop_free_code:
.outer:
	mov dx, -1			; remember no candidate
	xor si, si			; -> start of ext seg
.inner:
	cmp si, [relocateddata]
linkdatarelocation extseg_used		; behind last instance ?
	jae .end_inner			; yes -->
	cmp word [es:si + eldiStartCode], si
	jne .error			; start matches itself ?
	testopt [es:si + eldiFlags], eldifResident
	jnz .next_not_free		; is free ?
	mov dx, si			; -> candidate free block
	cmp byte [es:si + eldiStartData], 0
	jne .next_data_used		; is free ?
	cmp byte [es:si + eldiEndData], 0
	jne .next_data_used		; is free ?
	xor cx, cx			; remember candidate has no data
	jmp .next

.next_data_used:
	mov cx, 1			; remember candidate has data
	jmp .next

.next_not_free:
	mov dx, -1			; remember no candidate (used block)
.next:
	mov ax, si
	add ax, ELD_INSTANCE_size
	mov si, word [es:si + eldiEndCode]
	cmp si, ax
	jb .error
	jmp .inner

.error equ loop_free_data.error

.end_inner:
	cmp dx, -1			; last ELD instance is free ?
	je .end				; no -->
	xor bx, bx			; if to not keep ELD instance, = 0
	jcxz .free			; no data ? then use bx = 0 -->
	mov bl, 32			; need to keep ELD instance, = 32
.free:
	mov si, dx			; -> instance to free/resize
	mov ax, word [es:si + eldiEndCode]
	cmp ax, [relocateddata]		; validity check
linkdatarelocation extseg_used
	jne .error
	mov dx, word [es:si + eldiStartCode]
	sub ax, dx			; size of entire instance
	add dx, bx			; start of instance + how much to keep
	mov word [es:si + eldiEndCode], dx
					; enter into instance's end
	sub ax, bx			; size to discard
	sub word [relocateddata], ax	; do discard it
linkdatarelocation extseg_used
	test bx, bx			; only resized ?
	jz .outer			; no, go back try to free new last block

.end:


end:
	xor ax, ax
	retf


DATAOFFSET equ CODEOFFSET + code_size
	addsection DATA, follows=CODE vstart=_ELD_DATA_VSTART
%assign DATASECTION 1
%define DATAFIXUP - datastart + 0
datastart:

uinit_data:

	align 16, db 0
data_size equ $ - datastart

	absolute uinit_data

	alignb 16
uinit_data_end:

total_data_size equ $ - datastart
%assign _DATA_SIZE total_data_size

	usesection CODE

%include "eldlink.asm"

	align 16
code_size equ $ - code
